/**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2015-07-31
 */

public class Postfixrechner {
  private Stack<Integer> operanden;

  public Postfixrechner() {
    this.operanden = new Stack<Integer>();
  }

  public void bearbeiteOperand(int pZahl) {
    this.operanden.push(new Integer(pZahl));
  }

  public void bearbeiteOperator(char pOperator)  {
    int zahl2 = this.operanden.top().intValue();
    operanden.pop();
    int zahl1 = this.operanden.top().intValue();
    operanden.pop();
    int ergebnis = 0;
    switch (pOperator) {
      case '+': ergebnis = zahl1 + zahl2; break;
      case '-': ergebnis = zahl1 - zahl2; break;
      case '*': ergebnis = zahl1 * zahl2; break;
      case '/': ergebnis = zahl1 / zahl2; break;
    }
    this.operanden.push(new Integer(ergebnis));
  }

  public int gibTopwert() {
    int ergebnis = this.operanden.top().intValue();
    return ergebnis;
  }

}
